package be.iminds.ilabt.jfed.ui.cli2.instruction;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

public class ListResourcesInstruction extends Instruction {
    private final Boolean available;
    private final String testbedId; //testbedId (string), serverId (integer) or URN

    @JsonCreator
    public ListResourcesInstruction(@JsonProperty("action") @Nonnull Action action,
                                    @JsonProperty("user") @Nullable User user,
                                    @JsonProperty("actionOutputs") @Nullable List<ActionOutput> actionOutputs,
                                    @JsonProperty("debugOutputs") @Nullable List<DebugOutput> debugOutputs,
                                    @JsonProperty("callOutputs") @Nullable List<CallOutput> callOutputs,
                                    @JsonProperty("proxy") @Nullable ProxySettings proxy,
                                    @JsonProperty("available") @Nullable Boolean available,
                                    @JsonProperty("testbedId") @Nullable String testbedId) {
        super(action, user, actionOutputs, debugOutputs, callOutputs, proxy);
        this.available = available;
        this.testbedId = testbedId;
    }

    private ListResourcesInstruction(boolean demo) {
        super(Action.LISTRESOURCES, demo);
        this.available = false;
        this.testbedId = "testbedId";
    }

    @JsonProperty
    public Boolean getAvailable() {
        return available;
    }

    @JsonProperty
    public String getTestbedId() {
        return testbedId;
    }

    @JsonIgnore
    @Nonnull
    @Override
    public Action getActionOfClass() {
        return Action.LISTRESOURCES;
    }
}
